Loading...
Searching...
No Matches
juce::dsp::Polynomial< FloatingType > Class Template Reference

## Detailed Description

template<typename FloatingType>
class juce::dsp::Polynomial< FloatingType >

A class representing a polynomial.

The documentation for this class was generated from the following file:

- juce_dsp/maths/juce_Polynomial.h

## Public Member Functions

| Polynomial ()
| Creates a new polynomial which will always evaluate to zero.
| Polynomial (const FloatingType *coefficients, int numCoefficients)
| Creates a new polynomial with given coefficients.
| Polynomial (const Polynomial &)=default
| Creates a copy of another polynomial.
| Polynomial (Polynomial &&)=default
| Creates a copy of another polynomial.
Polynomial & | operator= (const Polynomial &)=default
| Creates a copy of another polynomial.
Polynomial & | operator= (Polynomial &&)=default
| Creates a copy of another polynomial.
template<typename... Values>
| Polynomial (Values... items)
| Creates a new polynomial with coefficients by a C++11 initializer list.
FloatingType | operator[] (int index) const noexcept
| Returns a single coefficient of the receiver for reading.
FloatingType & | operator[] (int index) noexcept
| Returns a single coefficient of the receiver for modifying.
FloatingType | operator() (FloatingType x) const noexcept
| Evaluates the value of the polynomial at a single point x.
int | getOrder () noexcept
| Returns the order of the polynomial.
Polynomial< FloatingType > | withGain (double gain) const
| Returns the polynomial with all its coefficients multiplied with a gain factor.
Polynomial< FloatingType > | getSumWith (const Polynomial< FloatingType > &other) const
| Returns the sum of this polynomial with another.
Polynomial< FloatingType > | getProductWith (const Polynomial< FloatingType > &other) const
| computes the product of two polynomials and return the result

## Constructors and Destructors

## Polynomial() [1/5]

template<typename FloatingType>

juce::dsp::Polynomial< FloatingType >::Polynomial | ( |  | ) |

inline

Creates a new polynomial which will always evaluate to zero.

Referenced by getProductWith(), getSumWith(), operator=(), operator=(), Polynomial(), Polynomial(), and withGain().

## Polynomial() [2/5]

template<typename FloatingType>

juce::dsp::Polynomial< FloatingType >::Polynomial | ( | const FloatingType * | coefficients,
|  | int | numCoefficients )

inline

Creates a new polynomial with given coefficients.

Parameters

  numCoefficients | The number of coefficients stored in coefficients. This is also the order of the returned polynomial.
  coefficients | The coefficients which will be used by the newly created polynomial. The Polynomial class will keep a private copy of the coefficients.

References jassert.

## Polynomial() [3/5]

template<typename FloatingType>

juce::dsp::Polynomial< FloatingType >::Polynomial | ( | const Polynomial< FloatingType > & |  | ) |

default

Creates a copy of another polynomial.

References Polynomial().

## Polynomial() [4/5]

template<typename FloatingType>

juce::dsp::Polynomial< FloatingType >::Polynomial | ( | Polynomial< FloatingType > && |  | ) |

default

Creates a copy of another polynomial.

References Polynomial().

## Polynomial() [5/5]

template<typename FloatingType>
template<typename... Values>

juce::dsp::Polynomial< FloatingType >::Polynomial | ( | Values... | items | ) |

inline

Creates a new polynomial with coefficients by a C++11 initializer list.

This function can be used in the following way: Polynomial<float> p ({0.5f, -0.3f, 0.2f});

References jassert.

## Member Functions

## operator=() [1/2]

template<typename FloatingType>

Polynomial & juce::dsp::Polynomial< FloatingType >::operator= | ( | const Polynomial< FloatingType > & |  | ) |

default

Creates a copy of another polynomial.

References Polynomial().

## operator=() [2/2]

template<typename FloatingType>

Polynomial & juce::dsp::Polynomial< FloatingType >::operator= | ( | Polynomial< FloatingType > && |  | ) |

default

Creates a copy of another polynomial.

References Polynomial().

## operator[]() [1/2]

template<typename FloatingType>

FloatingType juce::dsp::Polynomial< FloatingType >::operator[] | ( | int | index | ) | const

inline noexcept

Returns a single coefficient of the receiver for reading.

## operator[]() [2/2]

template<typename FloatingType>

FloatingType & juce::dsp::Polynomial< FloatingType >::operator[] | ( | int | index | ) |

inline noexcept

Returns a single coefficient of the receiver for modifying.

## operator()()

template<typename FloatingType>

FloatingType juce::dsp::Polynomial< FloatingType >::operator() | ( | FloatingType | x | ) | const

inline noexcept

Evaluates the value of the polynomial at a single point x.

References x, and y.

## getOrder()

template<typename FloatingType>

int juce::dsp::Polynomial< FloatingType >::getOrder | ( |  | ) |

inline noexcept

Returns the order of the polynomial.

## withGain()

template<typename FloatingType>

Polynomial< FloatingType > juce::dsp::Polynomial< FloatingType >::withGain | ( | double | gain | ) | const

inline

Returns the polynomial with all its coefficients multiplied with a gain factor.

References Polynomial().

## getSumWith()

template<typename FloatingType>

Polynomial< FloatingType > juce::dsp::Polynomial< FloatingType >::getSumWith | ( | const Polynomial< FloatingType > & | other | ) | const

inline

Returns the sum of this polynomial with another.

References getSumWith(), Polynomial(), and juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::size().

Referenced by getSumWith().

## getProductWith()

template<typename FloatingType>

Polynomial< FloatingType > juce::dsp::Polynomial< FloatingType >::getProductWith | ( | const Polynomial< FloatingType > & | other | ) | const

inline

computes the product of two polynomials and return the result

References juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::add(), juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::clearQuick(), juce::jmax(), Polynomial(), and juce::Array< ElementType, TypeOfCriticalSectionToUse, minimumAllocatedSize >::size().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited